typedef void * T;
typedef struct {
	int (*priority)(T);
} TDescription;

typedef struct {
	TDescription desc;
	void *data;
} PriorityQueue;

PriorityQueue *NewPriorityQueue(TDescription);
void Add(PriorityQueue *, T);
T Pop(PriorityQueue *);
