#include <stdlib.h>
#include "PriorityQueue.h"

typedef struct {
	T e[255];
	int n;
} QData;

PriorityQueue *NewPriorityQueue(TDescription desc) {
	PriorityQueue *q = malloc(sizeof(PriorityQueue));
	q->desc = desc;
	q->data = malloc(sizeof(QData));
	((QData *)q->data)->n = 0;
	return q;
}

void Add(PriorityQueue *q, T t) {
	QData *qdata = (QData *)q->data;
	qdata->e[qdata->n++] = t;
}
	
T Pop(PriorityQueue *q) {
	QData *qdata = (QData *)q->data;
	if (qdata->n == 0) return NULL;
	int i, itop = 0;
	for (i = 0; i < qdata->n; i++)
		if (q->desc.priority(qdata->e[i]) >
		    q->desc.priority(qdata->e[itop]))
			itop = i;
	T top = qdata->e[itop];
	for (int j = i; j < qdata->n-1; j++)
		qdata->e[j] = qdata->e[j+1];
	qdata->n--;
	return top;
}
