#include <stdio.h>
#include <string.h>
#include "PriorityQueue.h"

int count_stars(void *v) {
	char *s = (char *)v;
	int i = 0;
	while (i < strlen(s) && s[i] == '*') i++;
	return i;
}
TDescription str_desc = { .priority = count_stars };

int main() {
	PriorityQueue *q = NewPriorityQueue(str_desc);
	char *s = "Boring task";
	char *t = "* Eat dinner";
	char *u = "**** Write blog post!";
	Add(q, s);
	Add(q, t);
	Add(q, u);
	char *first = Pop(q);
	char *second = Pop(q);
	printf("First thing to do is '%s', followed by '%s'\n", first, second);
	return 0;
}
